package com.zhongzheng.modules.system.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseHandoutsBusinessAddBo;
import com.zhongzheng.modules.course.domain.CourseHandoutsBusiness;
import com.zhongzheng.modules.system.bo.SysRoleBusinessAddBo;
import com.zhongzheng.modules.system.bo.SysRoleBusinessEditBo;
import com.zhongzheng.modules.system.bo.SysRoleBusinessQueryBo;
import com.zhongzheng.modules.system.domain.SysRoleBusiness;
import com.zhongzheng.modules.system.mapper.SysRoleBusinessMapper;
import com.zhongzheng.modules.system.service.ISysRoleBusinessService;
import com.zhongzheng.modules.system.vo.SysRoleBusinessVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 角色和业务层次关联Service业务层处理
 *
 * @author ruoyi
 * @date 2022-01-18
 */
@Service
public class SysRoleBusinessServiceImpl extends ServiceImpl<SysRoleBusinessMapper, SysRoleBusiness> implements ISysRoleBusinessService {

    @Override
    public SysRoleBusinessVo queryById(Long id){
        SysRoleBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, SysRoleBusinessVo.class);
    }

    @Override
    public List<SysRoleBusinessVo> queryList(SysRoleBusinessQueryBo bo) {
        LambdaQueryWrapper<SysRoleBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getRoleId() != null, SysRoleBusiness::getRoleId, bo.getRoleId());
        lqw.eq(bo.getBusinessId() != null, SysRoleBusiness::getBusinessId, bo.getBusinessId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<SysRoleBusinessVo> entity2Vo(Collection<SysRoleBusiness> collection) {
        List<SysRoleBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, SysRoleBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<SysRoleBusiness> page = (Page<SysRoleBusiness>)collection;
            Page<SysRoleBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(SysRoleBusinessAddBo bo) {
        SysRoleBusiness add = BeanUtil.toBean(bo, SysRoleBusiness.class);
        validEntityBeforeSave(add);
        return this.save(add);

    }

    @Override
    public Boolean updateByEditBo(SysRoleBusinessEditBo bo) {
        SysRoleBusiness update = BeanUtil.toBean(bo, SysRoleBusiness.class);
        validEntityBeforeSave(update);
        return this.updateById(update);

    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(SysRoleBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
